# Get PNR

This endpoint gets PNR for a given trip ID and PNR ID.

Endpoint: GET /v3/trips/{tripId}/pnrs/{pnrId}
Version: v2
Security: Bearer

## Security:

  - `Bearer` (unknown)
    http bearer

## Path parameters:

  - `tripId` (string, required)
    Trip ID

  - `pnrId` (string, required)
    Pnr Id

## Response 200:

  - `200` (unknown)
    OK

## Response 200 fields (application/json):

  - `version` (integer)
    Current PNR version. This field is used for handling conflicts in case of concurrent 
updates. This should be sent unmodified in update request.
    Example: 1

  - `createdVia` (string)
    Indicates the source of creation of PNR, like SHELL, OBT, etc.
    Enum: "OFFLINE", "OBT", "SHELL", "PASSIVE", "API"

  - `sourceInfo` (object)
    Information about the source of booking

  - `sourceInfo.sourcePnrId` (string)
    The source PNR ID
    Example: AEDAVF

  - `sourceInfo.bookingSource` (string, required)
    The source of booking
    Example: United.com

  - `sourceInfo.thirdParty` (string)
    The known third party source of the booking.
    Example: United.com

  - `sourceInfo.bookingDateTime` (object)
    ISO8601 UTC Date Time

  - `sourceInfo.bookingDateTime.iso8601` (string, required)
    Example: 2017-07-21T17:32Z

  - `sourceInfo.posDescriptor` (string)
    Point of sale descriptor for this pnr from source
    Example: LA5K

  - `sourceInfo.iataNumber` (string)
    IATA number associated with this pnr
    Example: 426666

  - `invoiceDelayedBooking` (boolean)
    True if the billing is delayed
    Example: false

  - `travelers` (array)

  - `travelers.travelerPersonalInfo` (object)
    Traveler personal information.

  - `travelers.travelerPersonalInfo.loyaltyInfos` (array)

  - `travelers.travelerPersonalInfo.loyaltyInfos.appliedTo` (array)

  - `travelers.travelerPersonalInfo.loyaltyInfos.id` (string, required)
    Example: firstId

  - `travelers.travelerPersonalInfo.loyaltyInfos.issuedBy` (string, required)
    Example: firstIssuedBy

  - `travelers.travelerPersonalInfo.loyaltyInfos.type` (string, required)
    Enum: "UNKNOWN_TYPE", "AIR", "HOTEL", "CAR", "RAIL"

  - `travelers.travelerPersonalInfo.loyaltyInfos.linked` (boolean)
    Indicates if this loyalty account is linked to the external provider. Only applicable for certain loyalty types.
    Example: false

  - `travelers.travelerPersonalInfo.loyaltyInfos.tier` (string)
    Loyalty membership tier name echoed from the supplier.
    Example: GOLD

  - `travelers.travelerPersonalInfo.travelPref` (object)
    Travel preferences.

  - `travelers.travelerPersonalInfo.travelPref.airPref` (object)
    Travel preferences related to air travel.

  - `travelers.travelerPersonalInfo.travelPref.airPref.airlinePrefs` (array)

  - `travelers.travelerPersonalInfo.travelPref.airPref.airlinePrefs.airlines` (array)

  - `travelers.travelerPersonalInfo.travelPref.airPref.airlinePrefs.flightType` (string)
    Enum: "UNKNOWN_FLIGHT_TYPE", "DOMESTIC", "INTERNATIONAL", "ALL"

  - `travelers.travelerPersonalInfo.travelPref.airPref.alliancePref` (object)
    Alliance preferences.

  - `travelers.travelerPersonalInfo.travelPref.airPref.alliancePref.alliances` (array, required)

  - `travelers.travelerPersonalInfo.travelPref.airPref.farePref` (object)
    Fare preferences.

  - `travelers.travelerPersonalInfo.travelPref.airPref.farePref.fareTypes` (array, required)

  - `travelers.travelerPersonalInfo.travelPref.airPref.homeAirport` (string)
    Example: NEW YORK

  - `travelers.travelerPersonalInfo.travelPref.airPref.mealPref` (object)
    Meal preferences.

  - `travelers.travelerPersonalInfo.travelPref.airPref.mealPref.exclMealPrefs` (array)

  - `travelers.travelerPersonalInfo.travelPref.airPref.mealPref.inclMealPrefs` (array)

  - `travelers.travelerPersonalInfo.travelPref.airPref.mealPref.specialMealDescription` (string)
    Example: Veg only meal

  - `travelers.travelerPersonalInfo.travelPref.airPref.numStopPref` (object)
    Preferred number of stops.

  - `travelers.travelerPersonalInfo.travelPref.airPref.numStopPref.numOfStops` (integer, required)
    Example: 34

  - `travelers.travelerPersonalInfo.travelPref.airPref.seatAmenityPref` (object)
    Seat amenity preference.

  - `travelers.travelerPersonalInfo.travelPref.airPref.seatAmenityPref.seatAmenityTypes` (array, required)

  - `travelers.travelerPersonalInfo.travelPref.airPref.seatLocationPrefs` (array)

  - `travelers.travelerPersonalInfo.travelPref.airPref.seatLocationPrefs.cabins` (array)

  - `travelers.travelerPersonalInfo.travelPref.airPref.seatLocationPrefs.isBulkHeadPref` (boolean)
    Example: false

  - `travelers.travelerPersonalInfo.travelPref.airPref.seatLocationPrefs.maxFlightDurationInHours` (integer)
    Example: 3

  - `travelers.travelerPersonalInfo.travelPref.airPref.seatLocationPrefs.position` (string)
    Enum: "UNKNOWN_POSITION", "AISLE", "WINDOW", "AISLE_OR_WINDOW"

  - `travelers.travelerPersonalInfo.travelPref.airPref.preferredAirports` (array)
    A list of user preferred airports.

  - `travelers.travelerPersonalInfo.travelPref.airPref.preferredAirports.airportName` (string)
    Airport name.
    Example: San Francisco International Airport

  - `travelers.travelerPersonalInfo.travelPref.airPref.preferredAirports.airportCode` (string, required)
    IATA airport code.
    Example: SFO

  - `travelers.travelerPersonalInfo.travelPref.airPref.preferredAirports.label` (string, required)
    The label of preferred airport or rail station.
    Enum: "HOME", "WORK", "OTHER"

  - `travelers.travelerPersonalInfo.travelPref.preferredCurrency` (string)
    Example: USD

  - `travelers.travelerPersonalInfo.travelPref.railCards` (array)

  - `travelers.travelerPersonalInfo.travelPref.railCards.cardNumber` (string)
    Number of card

  - `travelers.travelerPersonalInfo.travelPref.railCards.expiryDate` (object)
    Date in ISO 8601 standard.

  - `travelers.travelerPersonalInfo.travelPref.railCards.expiryDate.iso8601` (string, required)
    Example: 2017-07-21

  - `travelers.travelerPersonalInfo.travelPref.railCards.name` (string, required)
    Name of the Rail Card.
    Example: Veterans Railcard

  - `travelers.travelerPersonalInfo.travelPref.railCards.spotnanaCode` (string, required)
    Unique Spotnana code/identifier for Rail Card.
    Example: VET

  - `travelers.travelerPersonalInfo.travelPref.railCards.vendor` (string, required)
    Vendor Name.
    Example: ATOC

  - `travelers.travelerPersonalInfo.travelPref.railPref` (object)
    Travel preferences related to rail station.

  - `travelers.travelerPersonalInfo.travelPref.railPref.preferredRailStations` (array)
    A list of user preferred rail stations.

  - `travelers.travelerPersonalInfo.travelPref.railPref.preferredRailStations.stationName` (string)
    Rail station name.
    Example: Chicago Union Station

  - `travelers.travelerPersonalInfo.travelPref.railPref.preferredRailStations.stationCode` (string, required)
    Rail station code.
    Example: CHI

  - `travelers.travelerPersonalInfo.travelPref.railPref.preferredRailStations.cityName` (string)
    Name of city where the rail station is located.
    Example: Chicago

  - `travelers.travelerPersonalInfo.travelPref.railPref.preferredRailStations.countryCode` (string)
    Alpha-2 country code where the rail station is located.

  - `travelers.travelerPersonalInfo.travelPref.railPref.seatPreference` (object)
    Preference about seat of rail.

  - `travelers.travelerPersonalInfo.travelPref.railPref.seatPreference.hasAccessibility` (boolean)
    Whether or not requires assistance for disability.
    Example: false

  - `travelers.travelerPersonalInfo.travelPref.railPref.seatPreference.seatTypes` (array)

  - `travelers.travelerPersonalInfo.travelPref.railPref.seatPreference.seatLocations` (array)

  - `travelers.travelerPersonalInfo.travelPref.railPref.seatPreference.deckLevels` (array)

  - `travelers.travelerPersonalInfo.travelPref.railPref.seatPreference.seatDirections` (array)

  - `travelers.travelerPersonalInfo.travelPref.railPref.travelClasses` (array)
    A list of class of service for rail.

  - `travelers.travelerPersonalInfo.travelPref.railPref.coachPreferences` (array)
    A list of coach preference for rail.

  - `travelers.travelerPersonalInfo.travelPref.railPref.conditionalRates` (array)
    A list of conditional rates for rail.

  - `travelers.travelerPersonalInfo.travelPref.carPref` (object)
    Travel preferences related to car.

  - `travelers.travelerPersonalInfo.travelPref.carPref.vendors` (array)
    A list of car vendors.

  - `travelers.travelerPersonalInfo.travelPref.carPref.vendors.code` (string, required)
    Vendor code
    Example: ZE

  - `travelers.travelerPersonalInfo.travelPref.carPref.vendors.name` (string, required)
    Vendor name
    Example: HERTZ

  - `travelers.travelerPersonalInfo.travelPref.carPref.vendors.isPresentInPreferredVendors` (boolean)
    Whether the car vendor is present in preferred vendor list. This is an optional field which gets populated only in the preferred vendor autocomplete API.
    Example: true

  - `travelers.travelerPersonalInfo.travelPref.carPref.carTypes` (array)
    A list of types of car.

  - `travelers.travelerPersonalInfo.travelPref.carPref.engineTypes` (array)
    A list of types of engine.

  - `travelers.travelerPersonalInfo.travelPref.carPref.transmissionTypes` (array)
    A list of types of transmission.

  - `travelers.travelerPersonalInfo.travelPref.carPref.conditionalRates` (array)
    A list of conditional rates for rail.

  - `travelers.travelerPersonalInfo.travelPref.hotelPref` (object)
    Travel preferences related to hotel.

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.hotelParentChains` (array)
    A list of hotel parent chains.

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.hotelParentChains.chainCode` (string)
    The code of hotel chain.
    Example: EM

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.hotelParentChains.chainName` (string)
    The name of hotel chain.
    Example: Mariott

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.hotelBrands` (array)
    A list of hotel brands.

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.hotelBrands.brandCode` (string)
    The code of hotel brand.
    Example: HY

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.hotelBrands.brandName` (string)
    The name of hotel brand.
    Example: Global Hytt Corp.

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.hotelAmenityTypes` (array)
    A list of HotelAmenities.

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.roomPreference` (object)
    Room options and stay preference.

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.roomPreference.isMobilityAccessible` (boolean)
    Whether or not mobility accessible room, tub.
    Example: false

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.roomPreference.bedCount` (string)
    The number of bed in the room.
    Enum: "ONE_BED", "TWO_BEDS"

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.roomPreference.roomType` (string)
    Single selection of type of room.
    Enum: "SMOKING", "NON_SMOKING"

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.roomPreference.mostImportantFact` (string)
    Single selection of the most import fact.
    Enum: "ROOM_TYPE", "BED_COUNT", "ROOM_LOCATION"

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.roomPreference.roomLocation` (string)
    Location of the hotel room
    Enum: "HIGH_FLOOR", "LOW_FLOOR", "NEAR_ELEVATOR"

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.roomPreference.pillowType` (string)
    The type of pillow in hotel room.
    Enum: "FOAM", "EXTRA_FOAM", "EXTRA_FEATHER"

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.roomPreference.roomAmenityPrefs` (array)

  - `travelers.travelerPersonalInfo.travelPref.hotelPref.conditionalRates` (array)
    A list of conditional rates for rail.

  - `travelers.travelerPersonalInfo.blockLoyalty` (boolean)
    If true, hides the loyalty program input on the checkout page for this traveler.
    Example: false

  - `travelers.user` (object)
    User details.

  - `travelers.user.addresses` (array)

  - `travelers.user.addresses.addressLines` (array, required)
    Address lines

  - `travelers.user.addresses.administrativeArea` (string)
    Code of administrative area. For example: DL for Delhi, India.
Highest administrative subdivision which is used for postal
addresses of a country or region.
For example, this can be a state, a province, an oblast, or a prefecture.
Specifically, for Spain this is the province and not the autonomous
community (e.g. "Barcelona" and not "Catalonia").
Many countries don't use an administrative area in postal addresses. E.g.
in Switzerland this should be left unpopulated.
    Example: CA

  - `travelers.user.addresses.administrativeAreaName` (string)
    Name of administrative area. This is full name corresponding to administrativeArea. 
Like Delhi for DL area code. For some places, code and name maybe same as well like Tokyo.
    Example: California

  - `travelers.user.addresses.description` (string)
    Address description
    Example: San Francisco Home

  - `travelers.user.addresses.isDefault` (boolean)
    Whether this address is default address in case multiple addresses are specified.
    Example: true

  - `travelers.user.addresses.languageCode` (string)
    BCP-47 language code of the contents of this address (if known). This is often the UI 
language of the input form or is expected to match one of the languages used in the 
address' country/region, or their transliterated equivalents.
This can affect formatting in certain countries, but is not critical to the correctness 
of the data and will never affect any validation or other non-formatting related operations.
Examples: "zh-Hant", "ja", "ja-Latn", "en".
    Example: en

  - `travelers.user.addresses.locality` (string)
    Generally refers to the city/town portion of the address.
    Example: San Francisco

  - `travelers.user.addresses.locationCode` (string)
    IATA 3-letter location code. See https://www.iata.org/en/services/codes.
    Example: LAX

  - `travelers.user.addresses.organization` (string)
    The name of the organization at the address.
    Example: Spotnana

  - `travelers.user.addresses.postalCode` (string)
    Postal code of the address. This is a required field when setting for a user/legal entity/company etc.
    Example: 94130

  - `travelers.user.addresses.continentCode` (string)
    2 letter continent code of the continent this address falls in.
    Example: AF

  - `travelers.user.addresses.recipients` (array)
    The recipient at the address.

  - `travelers.user.addresses.regionCode` (string, required)
    Region code of the country/region of the address.
    Example: US

  - `travelers.user.addresses.regionName` (string)
    Region name of the country/region of the address.
    Example: America

  - `travelers.user.addresses.revision` (integer)
    Example: 1

  - `travelers.user.addresses.sortingCode` (string)
    Additional, country-specific, sorting code. This is not used
in most regions. Where it is used, the value is either a string like
"CEDEX", optionally followed by a number (e.g. "CEDEX 7"), or just a number
alone, representing the "sector code" (Jamaica), "delivery area indicator"
(Malawi) or "post office indicator" (e.g. Côte d'Ivoire).
    Example: Jamaica

  - `travelers.user.addresses.sublocality` (string)
    Sublocality of the address. This can be neighborhoods, boroughs, districts.

  - `travelers.user.addresses.timezone` (string)
    Time zone of the address.
    Example: America/Los_Angeles

  - `travelers.user.addresses.coordinates` (object)
    Latitude and Longitude for a Location

  - `travelers.user.addresses.coordinates.latitude` (number, required)
    Latitude of the Location
    Example: 77.1025

  - `travelers.user.addresses.coordinates.longitude` (number, required)
    Longitude of the Location
    Example: 28.7041

  - `travelers.user.email` (string)
    Example: example@email.com

  - `travelers.user.emergencyContactInfo` (object)
    Emergency contact information.

  - `travelers.user.emergencyContactInfo.designation` (string)
    Example: MANAGER

  - `travelers.user.emergencyContactInfo.email` (string, required)
    Example: emergency-contact@email.com

  - `travelers.user.emergencyContactInfo.name` (object)
    Full name containing first, middle, last (family) names, and suffix.

  - `travelers.user.emergencyContactInfo.name.family1` (string, required)
    Last (family) name.
    Example: Gandas

  - `travelers.user.emergencyContactInfo.name.family2` (string)
    Example: FamilyTwo

  - `travelers.user.emergencyContactInfo.name.given` (string, required)
    First (given) name.
    Example: Vichitr

  - `travelers.user.emergencyContactInfo.name.middle` (string)
    Middle name.
    Example: Kumar

  - `travelers.user.emergencyContactInfo.name.suffix` (string)
    Suffix for name
    Enum: "NAME_SUFFIX_UNKNOWN", "SR", "JR", "MD", "PHD", "II", "III", "IV", "DO", "ATTY", "V", "VI", "ESQ", "DC", "DDS", "VM", "JD", "SECOND", "THIRD"

  - `travelers.user.emergencyContactInfo.name.preferred` (string)
    Informal preferred name added by traveler. This is not used on any PNR or tickets
    Example: Don

  - `travelers.user.emergencyContactInfo.phoneNumber` (object)
    Properly formatted phone number.

  - `travelers.user.emergencyContactInfo.phoneNumber.countryCode` (integer)
    two digit country code
    Example: 91

  - `travelers.user.emergencyContactInfo.phoneNumber.countryCodeSource` (string)
    Enum: "UNSPECIFIED", "FROM_NUMBER_WITH_PLUS_SIGN", "FROM_NUMBER_WITH_IDD", "FROM_NUMBER_WITHOUT_PLUS_SIGN", "FROM_DEFAULT_COUNTRY"

  - `travelers.user.emergencyContactInfo.phoneNumber.extension` (string)
    phone number extension
    Example: 222

  - `travelers.user.emergencyContactInfo.phoneNumber.isoCountryCode` (string)
    ISO alpha-2 code
    Example: IN

  - `travelers.user.emergencyContactInfo.phoneNumber.italianLeadingZero` (boolean)
    Example: true

  - `travelers.user.emergencyContactInfo.phoneNumber.nationalNumber` (integer)
    Example: 8150

  - `travelers.user.emergencyContactInfo.phoneNumber.numberOfLeadingZeros` (integer)
    Example: 1

  - `travelers.user.emergencyContactInfo.phoneNumber.preferredDomesticCarrierCode` (string)
    Example: 7

  - `travelers.user.emergencyContactInfo.phoneNumber.rawInput` (string)
    Example: 77777

  - `travelers.user.emergencyContactInfo.phoneNumber.type` (string)
    Enum: "UNKNOWN_TYPE", "MOBILE", "LANDLINE"

  - `travelers.user.emergencyContactInfo.userOrgId` (object)
    User and user's organization information.

  - `travelers.user.emergencyContactInfo.userOrgId.organizationAgencyId` (object)
    Agency id for the organization.

  - `travelers.user.emergencyContactInfo.userOrgId.organizationAgencyId.id` (string, required)

  - `travelers.user.emergencyContactInfo.userOrgId.organizationId` (object, required)
    Organization id for traveler.

  - `travelers.user.emergencyContactInfo.userOrgId.organizationId.id` (string, required)

  - `travelers.user.emergencyContactInfo.userOrgId.userId` (object, required)
    User identifier

  - `travelers.user.emergencyContactInfo.userOrgId.userId.id` (string, required)

  - `travelers.user.emergencyContactInfo.userOrgId.tmcInfo` (object)
    TMC config information.

  - `travelers.user.emergencyContactInfo.userOrgId.tmcInfo.id` (object, required)
    Company ID

  - `travelers.user.emergencyContactInfo.userOrgId.tmcInfo.id.id` (string, required)
    Example: f49d00fe-1eda-4304-ba79-a980f565281d

  - `travelers.user.emergencyContactInfo.userOrgId.tmcInfo.primaryServiceProviderTmc` (object, required)
    Primary service provider TMC info

  - `travelers.user.emergencyContactInfo.userOrgId.tmcInfo.secondaryServiceProviderTmcs` (array)
    Secondary service provider TMCs for the TMC.

  - `travelers.user.emergencyContactInfo.userOrgId.tmcInfo.secondaryServiceProviderTmcs.supplier` (string, required)
    Supplier type like Sabre, TravelFusion etc.
    Enum: "SABRE", "AMADEUS", "TRAVEL_FUSION", "FARELOGIX_NDC", "ATPCO_NDC", "TRAINLINE", "AVIA", "QBR", "BCD", "QANTAS_HOTELS", "SOUTHWEST", "EXPEDIA", "HOTEL_HUB", "NDC", "MARRIOTT", "CLEARTRIP", "KYTE", "GROUNDSPAN", "SABRE_NDC", "BOOKING_COM", "CARTRAWLER", "PREMIER_INN", "TRAVELODGE", "ENTERPRISE", "HYATT", "HILTON", "NATIONAL", "ALAMO", "HERTZ", "DOLLAR", "THRIFTY", "FIREFLY", "EUROSTAR", "AVIS", "BUDGET", "AMADEUS_NDC", "SIXT"

  - `travelers.user.emergencyContactInfo.userOrgId.tmcInfo.secondaryServiceProviderTmcs.travelType` (string, required)
    Travel Type
    Enum: "AIR", "HOTEL", "CAR", "RAIL", "LIMO", "MISC", "ALL"

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo` (object)
    TMC related basic information.

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc` (object, required)
    Basic information about a company.

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc.name` (string)

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc.logo` (object)
    An image with meta data. Either the `data` or `url` property must be supplied to load the image.

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc.logo.data` (string)
    Example: 6935813e12584abda0e43d71cd2ea260

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc.logo.dimensions` (object)
    Image dimensions ie width and height.

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc.logo.dimensions.height` (integer)
    Example: 120

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc.logo.dimensions.width` (integer)
    Example: 240

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc.logo.url` (string)
    Example: https://static.wixstatic.com/media/73f2e2_6935813e12584abda0e43d71cd2ea260~mv2.png/v1/fill/w_630,h_94,al_c,q_85,usm_0.66_1.00_0.01/Spotnana%403x.webp

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc.logo.metadata` (object)
    Metadata associated with an image.

  - `travelers.user.emergencyContactInfo.userOrgId.tmcBasicInfo.contractingTmc.logo.metadata.variant` (string)
    Image variant.
    Enum: "LIGHT", "DARK"

  - `travelers.user.emergencyContact` (object)
    Emergency contact information.

  - `travelers.user.emergencyContact.name` (string, required)
    Full name of contact.
    Example: John Smith

  - `travelers.user.emergencyContact.email` (string)
    Email address of contact.
    Example: emergency-contact@email.com

  - `travelers.user.emergencyContact.designation` (string)
    Job title of contact.
    Example: MANAGER

  - `travelers.user.emergencyContact.relation` (string)
    Relation of contact to user.
    Enum: "RELATION_UNKNOWN", "SPOUSE", "PARENT", "SIBLING", "CHILD", "FRIEND", "RELATIVE", "COLLEAGUE", "OTHER"

  - `travelers.user.emergencyContact.phoneNumbers` (array, required)
    Phone numbers of contact.

  - `travelers.user.emergencyContact.preferredLanguage` (string)
    Language preferred by user.
    Example: en-US

  - `travelers.user.gender` (string)
    Enum: "MALE", "FEMALE", "UNSPECIFIED", "UNDISCLOSED", "GENDER_REDACTED"

  - `travelers.user.identityDocs` (array)
    List of user identity documents.
    Example: [{"passport":{"docId":"PASSPORTID","expiryDate":{"iso8601":"2017-07-21"},"issueCountry":"IN","issuedDate":{"iso8601":"2017-07-21"},"nationalityCountry":"IN","type":"REGULAR"}},{"ktn":{"number":"123456…

  - `travelers.user.identityDocs.passport` (object)
    Passport details.

  - `travelers.user.identityDocs.passport.docId` (string, required)
    Example: PassportID

  - `travelers.user.identityDocs.passport.issueCountry` (string, required)
    Example: IN

  - `travelers.user.identityDocs.passport.nationalityCountry` (string, required)
    Example: IN

  - `travelers.user.identityDocs.passport.type` (string)
    Enum: "UNKNOWN", "REGULAR"

  - `travelers.user.identityDocs.immigrationDoc` (object)
    Immigration document details.

  - `travelers.user.identityDocs.immigrationDoc.authorizedStayDuration` (object)
    Represents a duration of time with specific units of time.

  - `travelers.user.identityDocs.immigrationDoc.authorizedStayDuration.iso8601` (string)
    Durations define the amount of intervening time in a time interval and are represented by the
format P[n]Y[n]M[n]DT[n]H[n]M[n]S.
The [n] is replaced by the value for each of the date and time elements that follow the [n].
Leading zeros are not required. The capital letters P, Y, M, W, D, T, H, M, and S are
designators for each of the date and time elements and are not replaced. P is the duration
designator (for period) placed at the start of the duration representation.
Y is the year designator.
M is the month designator.
W is the week designator.
D is the day designator.
T is the time designator.
H is the hour designator.
M is the minute designator.
S is the second designator and can include decimal digits with arbitrary precision.
    Example: PT19H55M

  - `travelers.user.identityDocs.immigrationDoc.docId` (string, required)
    The ID of the immigration document.
    Example: ImmigrationDocumentID

  - `travelers.user.identityDocs.immigrationDoc.issueCountry` (string, required)
    The country that issued the immigration document.
    Example: IN

  - `travelers.user.identityDocs.immigrationDoc.nationalityCountry` (string)
    Example: IN

  - `travelers.user.identityDocs.immigrationDoc.type` (string)
    Enum: "UNKNOWN", "VISA"

  - `travelers.user.identityDocs.redress` (object)
    Redress details

  - `travelers.user.identityDocs.redress.number` (string, required)
    Example: 12345

  - `travelers.user.identityDocs.redress.issueCountry` (string, required)
    Example: US

  - `travelers.user.identityDocs.ktn` (object)
    Information about the Known Traveler Number (KTN).

  - `travelers.user.identityDocs.ktn.number` (string, required)
    Example: 12345

  - `travelers.user.identityDocs.ktn.issueCountry` (string, required)
    Example: US

  - `travelers.user.identityDocs.nationalDoc` (object)
    National Document Id details.

  - `travelers.user.identityDocs.nationalDoc.docId` (string, required)
    Unique id identifying the national document.
    Example: NationalDocId

  - `travelers.user.identityDocs.nationalDoc.issueCountry` (string, required)
    IS0 2 letter country code of the country issuing this id.
    Example: IN

  - `travelers.user.identityDocs.nationalDoc.type` (string)
    Enum: "DNI", "NIE", "CPF", "MTP", "CIN", "NID"

  - `travelers.user.paymentInfos` (array)

  - `travelers.user.paymentInfos.applicableTo` (array)

  - `travelers.user.paymentInfos.card` (object, required)
    User card info

  - `travelers.user.paymentInfos.card.id` (string)
    Unique identifier for this card
    Example: 34d536b6-f8ff-11eb-9a61-0242ac180002

  - `travelers.user.paymentInfos.card.type` (string)
    Type of card
    Enum: "UNKNOWN", "CREDIT", "DEBIT"

  - `travelers.user.paymentInfos.card.company` (string)
    The issuing company of card
    Enum: "NONE", "VISA", "MASTERCARD", "AMEX", "DISCOVER", "AIR_TRAVEL_UATP", "CARTE_BLANCHE", "DINERS_CLUB", "JCB", "BREX", "UNION_PAY", "EURO_CARD", "ACCESS_CARD", "ELO_CARD"

  - `travelers.user.paymentInfos.card.name` (string)
    Name on card
    Example: Harrison Schwartz

  - `travelers.user.paymentInfos.card.number` (string, required)
    Card number
    Example: 4111111111111111

  - `travelers.user.paymentInfos.card.expiryMonth` (integer)
    Expiry month
    Example: 1

  - `travelers.user.paymentInfos.card.expiryYear` (integer)
    Expiry year
    Example: 2010

  - `travelers.user.paymentInfos.card.cvv` (string)
    Card cvv number
    Example: 012

  - `travelers.user.paymentInfos.card.label` (string)
    Card Label
    Example: Label amex

  - `travelers.user.paymentInfos.card.currency` (string)
    Native currency of the card.
    Example: USD

  - `travelers.user.paymentInfos.card.externalId` (string)
    Spotnana partner card id.
    Example: bxt_RNGsNfzgJDaTstKIKqK4xEuhGYAnMdYK8T40

  - `travelers.user.paymentInfos.card.vaultId` (string)
    ID of the vault used for creating the card.
    Example: 34d536b6-f8ff-11eb-9a61-0242ac180002

  - `travelers.user.paymentInfos.card.expiry` (object)
    Contains the expiry of a Card.

  - `travelers.user.paymentInfos.card.expiry.tokenizedExpiry` (object)
    Contains the tokenized expiry of a Card.

  - `travelers.user.paymentInfos.card.expiry.tokenizedExpiry.expiryMonth` (string, required)
    Tokenized Expiry month
    Example: KvAuPANQWCpjwRQxcC8EXg==

  - `travelers.user.paymentInfos.card.expiry.tokenizedExpiry.expiryYear` (string, required)
    Tokenized Expiry year
    Example: fPBm0OWrKwPyIrCVcbg4cA==

  - `travelers.user.paymentInfos.card.expiry.expiry` (object)
    Contains the expiry of a Card.

  - `travelers.user.paymentInfos.card.expiry.expiry.expiryMonth` (integer, required)
    Expiry month
    Example: 1

  - `travelers.user.paymentInfos.card.expiry.expiry.expiryYear` (integer, required)
    Expiry year
    Example: 2010

  - `travelers.user.paymentInfos.card.ownershipLabel` (string)
    Ownership label of the card whether it is personal, corporate or central.
    Enum: "CORPORATE", "PERSONAL", "CENTRAL"

  - `travelers.user.paymentInfos.accessType` (string)
    Identifies the different ways the card can be used across an organization
    Enum: "UNKNOWN_TYPE", "CENTRALISED", "INDIVIDUAL", "PERSONAL", "TMC", "APPLICATION", "ITINERARY", "EVENTS", "TRAVEL_ARRANGER_MANAGED", "COMPANY_TRAVEL_ARRANGER_MANAGED", "EVENT_TEMPLATE"

  - `travelers.user.paymentInfos.access` (object)
    Access type for cards to check who in the organization has permission to use it

  - `travelers.user.paymentInfos.access.entityIds` (array, required)
    Holds the ids for for all users who can access the card or organization id

  - `travelers.user.paymentInfos.access.entities` (array)
    A list of cardAccessEntity consisting of central card access level if present and entity id.

  - `travelers.user.paymentInfos.access.entities.entityId` (string, required)
    Holds the id for for the user who can access the card or organization id or legal entity

  - `travelers.user.paymentInfos.access.entities.centralCardAccessLevel` (string)
    Identifies at which level central card is applicable, for example organization or legal entity.
    Enum: "UNKNOWN", "ORGANIZATION", "LEGAL_ENTITY", "TMC"

  - `travelers.user.phoneNumbers` (array)

  - `travelers.user.nationality` (string)
    Nationality of user
    Example: Indian

  - `travelers.user.title` (string)
    Enum: "TITLE_UNKNOWN", "MR", "MS", "MRS", "MX", "MASTER", "MISS", "DR", "PROFESSOR", "CAPTAIN", "REVEREND", "HONOURABLE", "SIR", "LADY", "AMBASSADOR", "LORD", "BRIGADIER", "SENATOR", "DAME", "JUSTICE", "UK", "TITLE_REDACTED"

  - `travelers.userBusinessInfo` (object)
    User business information.

  - `travelers.userBusinessInfo.department` (object)
    Department details.

  - `travelers.userBusinessInfo.department.id` (object, required)
    Department id.

  - `travelers.userBusinessInfo.department.id.id` (string, required)
    Example: 631ccbcf-9414-5fe0-c234-b324dfbe7422

  - `travelers.userBusinessInfo.department.name` (string, required)
    Example: IT Department

  - `travelers.userBusinessInfo.department.externalId` (string)
    External id of the department
    Example: department-ext-id

  - `travelers.userBusinessInfo.department.employeeCount` (integer)
    Count of employees in the department
    Example: 57

  - `travelers.userBusinessInfo.designation` (string)
    Example: MANAGER

  - `travelers.userBusinessInfo.email` (string, required)
    Example: user@business.com

  - `travelers.userBusinessInfo.employeeId` (string, required)
    Unique employee id. Can use email if a company don't use employee ids.
    Example: 101

  - `travelers.userBusinessInfo.grade` (object)
    Grade details.

  - `travelers.userBusinessInfo.grade.employeeCount` (integer)
    Count of employees in the grade
    Example: 75

  - `travelers.userBusinessInfo.grade.id` (object, required)
    Grade id.

  - `travelers.userBusinessInfo.grade.id.id` (string, required)
    Example: 831ccbcb-1416-7fe2-e236-d324dfbe7424

  - `travelers.userBusinessInfo.grade.name` (string, required)
    Example: Grade

  - `travelers.userBusinessInfo.legalEntityId` (object, required)
    The ID of the legal entity.

  - `travelers.userBusinessInfo.legalEntityId.id` (string, required)
    Example: fc1ccbce-8413-4fe9-b233-a324dfbe7421

  - `travelers.userBusinessInfo.managerBasicInfo` (object)
    Basic user information.

  - `travelers.userBusinessInfo.managerBasicInfo.persona` (string)
    Persona of the user
    Enum: "UNKNOWN_PERSONA", "EMPLOYEE", "GUEST", "PERSONAL", "RELATIVE", "ADHOC"

  - `travelers.userBusinessInfo.managerBasicInfo.email` (string)
    Example: example@email.com

  - `travelers.userBusinessInfo.managerBasicInfo.tier` (string)
    Tier of User.
Note: In default UI, BASIC is displayed as Standard, and SEAT1A is displayed as VIP.
Display names for other tiers are driven by the company tier configuration.
    Enum: "BASIC", "SEAT1A", "TIER_2", "TIER_3", "TIER_4", "TIER_5", "TIER_6", "TIER_7", "TIER_8", "TIER_9", "TIER_10", "TIER_11", "TIER_12", "TIER_13", "TIER_14", "TIER_15", "TIER_16", "TIER_17", "TIER_18", "TIER_19", "TIER_20", "TIER_21", "TIER_22", "TIER_23", "TIER_24", "TIER_25", "TIER_26", "TIER_27", "TIER_28", "TIER_29", "TIER_30", "TIER_31"

  - `travelers.userBusinessInfo.managerBasicInfo.employeeId` (string)
    Employee id of the user

  - `travelers.userBusinessInfo.managerBasicInfo.isActive` (boolean)
    Whether user profile is active or not.
    Example: true

  - `travelers.userBusinessInfo.office` (object)
    Office details.

  - `travelers.userBusinessInfo.office.id` (object, required)
    The unique ID of the office.

  - `travelers.userBusinessInfo.office.id.id` (string, required)
    The value of the unique ID for the office.
    Example: 531ccbce-8413-4fe9-b233-a324dfbe7421

  - `travelers.userBusinessInfo.office.name` (string, required)
    Example: Office

  - `travelers.userBusinessInfo.office.taxId` (string)
    Example: 133232

  - `travelers.userBusinessInfo.phoneNumbers` (array)

  - `travelers.userBusinessInfo.userCostCenter` (object)
    Cost center details.

  - `travelers.userBusinessInfo.userCostCenter.id` (object, required)

  - `travelers.userBusinessInfo.userCostCenter.id.id` (string, required)
    Example: 731ccbca-0415-6fe1-d235-c324dfbe7423

  - `travelers.userBusinessInfo.userCostCenter.name` (string, required)
    Example: CostCenter

  - `travelers.userBusinessInfo.userCostCenter.externalId` (string)
    Example: external-id

  - `travelers.userBusinessInfo.designatedApproverInfos` (array)
    A list of user basic info for designated approvers.

  - `travelers.userBusinessInfo.designatedApproverUserIds` (array)
    A list of userId for designated approvers.

  - `travelers.userBusinessInfo.authorizerEmail` (string)
    Email address to be used as approval authorizer, when a manager is not present.
    Example: example@email.com

  - `travelers.isActive` (boolean)
    A boolean flag to show if traveler is active.
    Example: true

  - `travelers.adhocUserInfo` (object)
    Basic information related to ad-hoc traveler profile.

  - `travelers.adhocUserInfo.profileOwner` (object, required)
    Basic information about the owner of the ad-hoc user.

  - `travelers.adhocUserInfo.isSaved` (boolean)
    A boolean flag to show if ad-hoc traveler is visible in search. While updating the user 
if client tries to update this field, it will throw exception.

  - `travelers.externalId` (string)
    External id of this user.

  - `pnrTravelers` (array)
    List of travelers on this pnr and their information. This is a required field.

  - `pnrTravelers.travelerInfo` (object)
    The traveler identifiers. These can be either the Spotnana user IDs of the travelers or information regarding
the adhoc travelers.

  - `pnrTravelers.travelerInfo.adhocTravelerInfo` (object)
    Describes an adhoc traveler.

  - `pnrTravelers.travelerInfo.adhocTravelerInfo.externalId` (string)
    External Id of user
    Example: qwert123

  - `pnrTravelers.personalInfo` (object)
    User details.

  - `pnrTravelers.personalInfo.addresses` (array)

  - `pnrTravelers.personalInfo.email` (string)
    Example: example@email.com

  - `pnrTravelers.personalInfo.identityDocs` (array)
    List of user identity documents.
    Example: [{"passport":{"docId":"PASSPORTID","expiryDate":{"iso8601":"2017-07-21"},"issueCountry":"IN","issuedDate":{"iso8601":"2017-07-21"},"nationalityCountry":"IN","type":"REGULAR"}},{"ktn":{"number":"123456…

  - `pnrTravelers.personalInfo.phoneNumbers` (array)

  - `pnrTravelers.personalInfo.nationality` (string)
    Nationality of user
    Example: Indian

  - `pnrTravelers.personalInfo.preferredLanguage` (string)
    Language preferred by user.
    Example: en-US

  - `pnrTravelers.personalInfo.preferredPronoun` (string)
    Enum: "SHE_HER_HERS", "HE_HIM_HIS", "THEY_THEM_THEIRS"

  - `pnrTravelers.loyalties` (array)

  - `pnrTravelers.businessInfo` (object)
    Business information of the traveler

  - `pnrTravelers.businessInfo.legalEntity` (object)
    Legal entity of the traveler

  - `pnrTravelers.businessInfo.legalEntity.id` (string)
    Legal entity ID

  - `pnrTravelers.businessInfo.legalEntity.name` (string)
    Name of the legal entity
    Example: Spotnana India

  - `pnrTravelers.businessInfo.legalEntity.ein` (string)
    EIN of the traveler

  - `pnrTravelers.businessInfo.legalEntity.externalId` (string)
    External Id of the legal entity
    Example: abcd

  - `pnrTravelers.businessInfo.legalEntity.companySpecifiedAttributes` (array)

  - `pnrTravelers.businessInfo.legalEntity.companySpecifiedAttributes.fieldName` (string, required)
    Field name of the attribute
    Example: businessId

  - `pnrTravelers.businessInfo.legalEntity.companySpecifiedAttributes.value` (string, required)
    Field value of the attribute
    Example: ABCD

  - `pnrTravelers.businessInfo.legalEntity.countryCode` (string)
    2-letter ISO country code of the legal entity
    Example: IN

  - `pnrTravelers.businessInfo.legalEntity.billingCurrency` (string)
    Billing currency for the legal entity.
    Example: USD

  - `pnrTravelers.businessInfo.legalEntity.registeredName` (string)
    The official name of this legal entity as registered with local tax authorities.
    Example: Spotnana India Private Limited

  - `pnrTravelers.businessInfo.legalEntity.registeredEmail` (string)
    The primary email (or alias) used for the "Registered name" of this legal entity.
Used for official communications, including regulatory, compliance, and invoicing
purposes.
    Example: contact@spotnana.in

  - `pnrTravelers.businessInfo.companyInfo` (object)
    Company information of the traveler

  - `pnrTravelers.businessInfo.companyInfo.name` (string)
    Name of the company
    Example: Spotnana

  - `pnrTravelers.businessInfo.companyInfo.externalId` (string)
    External Id of the company
    Example: abcd

  - `pnrTravelers.businessInfo.workerType` (string)
    The type of worker.
    Enum: "EMPLOYEE", "CONTINGENT", "SEASONAL", "INTERN", "GUEST"

  - `pnrTravelers.businessInfo.employeeId` (string)
    Employee id of the user
    Example: 1234

  - `pnrTravelers.businessInfo.companySpecifiedAttributes` (array)

  - `pnrTravelers.businessInfo.companySpecifiedAttributes.fixedColumnName` (string, required)
    Example: contingentType

  - `pnrTravelers.businessInfo.companySpecifiedAttributes.value` (string, required)
    Example: FSTV

  - `pnrTravelers.businessInfo.department` (object)
    Department details.

  - `pnrTravelers.businessInfo.department.id` (string, required)

  - `pnrTravelers.businessInfo.department.name` (string, required)
    Name of the department
    Example: IT Department

  - `pnrTravelers.businessInfo.department.externalId` (string)
    External id of the department
    Example: department-ext-id

  - `pnrTravelers.businessInfo.accountingCode` (string)
    Code used for accounting.
    Example: 123

  - `pnrTravelers.blockLoyalty` (boolean)
    If true, hides the loyalty program input on the checkout page for this traveler.
    Example: false

  - `costOfGoodsSold` (object)
    Payment information about all goods sold. This is a required field for now.

  - `costOfGoodsSold.payments` (array, required)
    Potentially multiple payments that spotnana will pay to vendors for this booking

  - `costOfGoodsSold.payments.travelerIndices` (array, required)
    The list of traveler indices on which this payment applies.
    Example: [0,1]

  - `costOfGoodsSold.payments.userIds` (array)
    The list of traveler user IDs on which this payment applies.

  - `costOfGoodsSold.payments.amount` (object)
    Fare amount including base fare and tax.

  - `costOfGoodsSold.payments.amount.base` (object, required)
    Money object containing details such as the amount, the currency code, and the converted amount.

  - `costOfGoodsSold.payments.amount.base.amount` (number, required)
    The numeric value for the amount of money.
    Example: 510

  - `costOfGoodsSold.payments.amount.base.currencyCode` (string, required)
    The 3-letter currency code for the money amount (defined using ISO 4217 standard).
    Example: GBP

  - `costOfGoodsSold.payments.amount.base.convertedAmount` (number)
    The converted currency and amount that has been converted (if a currency conversion has been requested).
For example, if the call requests that money be sent in a specified currency (because the frontend requested
the backend to send money in the user's preferred currency).
    Example: 715.42

  - `costOfGoodsSold.payments.amount.base.convertedCurrency` (string)
    The 3-letter currency code for the converted currency (defined using ISO 4217 standard).
    Example: USD

  - `costOfGoodsSold.payments.amount.base.otherCoinage` (array)
    List of the dollar amount in other coinage systems like reward points, cryptocurrency etc.

  - `costOfGoodsSold.payments.amount.base.otherCoinage.coinageCode` (string)
    Payment method
    Enum: "PAYMENT_METHOD_UNKNOWN", "CREDIT_CARD", "BREX_POINTS", "CASH", "QANTAS_POINTS", "VENDOR_PROGRAM_PAYMENT", "DELAYED_INVOICING", "FLIGHT_CREDITS", "QANTAS_TRAVEL_FUND", "CUSTOM_VIRTUAL_PAYMENT", "FLIGHT_PASS", "MISCELLANEOUS_CREDIT_ORDER", "NO_PREPAYMENT", "DELAYED_PAYMENT"

  - `costOfGoodsSold.payments.amount.base.otherCoinage.amount` (number)
    Example: 1000

  - `costOfGoodsSold.payments.amount.base.otherCoinage.conversionRate` (number)
    1 coin in this system equals to how many currency value
    Example: 0.01

  - `costOfGoodsSold.payments.amount.base.otherCoinage.preferredCurrencyConversionRate` (number)
    1 coin in this system equals to how many currency value
    Example: 0.01

  - `costOfGoodsSold.payments.amount.base.otherCoinage.otherCoinageMetadata` (any)
    Metadata to store additional information related to the payment method

  - `costOfGoodsSold.payments.amount.base.otherCoinage.otherCoinageMetadata.metadataType` (string)
    Discriminator field for polymorphic deserialization
    Enum: "FlightPassPaymentMetadata"

  - `costOfGoodsSold.payments.amount.base.otherCoinage.otherCoinageMetadata.flightPassMetadata` (object, required)
    Metadata specific to Flight Pass payment method in OtherCoinage.

  - `costOfGoodsSold.payments.amount.base.otherCoinage.otherCoinageMetadata.flightPassMetadata.flightPassNumber` (string)
    Flight pass number
    Example: FP123456789

  - `costOfGoodsSold.payments.amount.base.otherCoinage.otherCoinageMetadata.flightPassMetadata.flightPassAmounts` (object)
    Fare breakdown for the flight pass booking.

  - `costOfGoodsSold.payments.amount.taxBreakdown` (array)

  - `costOfGoodsSold.payments.amount.taxBreakdown.taxCode` (string)
    Tax code
    Example: VAT

  - `costOfGoodsSold.payments.amount.taxBreakdown.percentage` (number)
    Tax amount to total amount
    Example: 9

  - `costOfGoodsSold.payments.amount.taxBreakdown.description` (string)
    Tax name or Tax Description
    Example: AIR TRAVELLERS SECURITY CHARGE

  - `costOfGoodsSold.payments.fop` (object)
    Information about form of payment to be used to charge customer

  - `costOfGoodsSold.payments.fop.type` (string)
    Type of payment used
    Enum: "UNKNOWN", "CARD", "CASH", "TFPAY", "CHEQUE", "BREX_POINTS", "QANTAS_POINTS"

  - `costOfGoodsSold.payments.fop.additionalInfo` (string)
    Additional info to be added if payment type is 'UNKNOWN'.

  - `costOfGoodsSold.payments.fop.paymentMetadata` (object)
    Payment metadata related to form of payment

  - `costOfGoodsSold.payments.fop.paymentMetadata.customPaymentMethodMetadata` (object)
    Metadata related to custom payment method

  - `costOfGoodsSold.payments.fop.paymentMetadata.customPaymentMethodMetadata.brexBudgetMetadata` (object)
    Metadata for Brex Budget

  - `costOfGoodsSold.payments.fop.paymentMetadata.customPaymentMethodMetadata.brexBudgetMetadata.budgetName` (string)
    Name of the budget
    Example: Travel budget

  - `costOfGoodsSold.payments.fop.paymentMetadata.customPaymentMethodMetadata.brexBudgetMetadata.paidByPersonalCard` (boolean)
    Whether it was paid by budget card or personal card
    Example: false

  - `costOfGoodsSold.payments.fop.paymentMetadata.customPaymentMethodMetadata.noPrepaymentMetadata` (object)
    Metadata for No Prepayment payment source (car bookings on no-guarantee rates).

  - `costOfGoodsSold.payments.fop.paymentMetadata.customPaymentMethodMetadata.noPrepaymentMetadata.label` (string, required)
    Label for No Prepayment payment source.
    Example: No Prepayment

  - `costOfGoodsSold.payments.fop.paymentMetadata.customPaymentMethodMetadata.virtualPaymentMetadata` (object)
    Metadata for custom virtual payment source.

  - `costOfGoodsSold.payments.fop.paymentMetadata.customPaymentMethodMetadata.virtualPaymentMetadata.label` (string, required)
    Label for custom virtual payment source.
    Example: Custom payment card

  - `costOfGoodsSold.payments.fop.paymentMetadata.customPaymentMethodMetadata.virtualPaymentMetadata.provider` (string)
    How this virtual payment source is integrated with Spotnana. EXTERNAL marks a virtual card deployed outside Spotnana (label-only, no card operations).
    Enum: "BCD", "EXTERNAL"

  - `costOfGoodsSold.payments.fop.paymentMetadata.vendorProgramPaymentMetadata` (object)
    Metadata related to vendor program payment method

  - `costOfGoodsSold.payments.fop.paymentMetadata.vendorProgramPaymentMetadata.directBilling` (object, required)
    Metadata for Direct Billing

  - `costOfGoodsSold.payments.fop.paymentMetadata.vendorProgramPaymentMetadata.directBilling.vendorId` (string, required)
    Unique vendor id/code
    Example: ZI

  - `costOfGoodsSold.payments.fop.paymentMetadata.vendorProgramPaymentMetadata.directBilling.directBillingCode` (string)
    Direct billing code provided by the vendor
    Example: 123456

  - `costOfGoodsSold.payments.fop.paymentMetadata.vendorProgramPaymentMetadata.uaPassPlusMetadata` (object, required)
    Details for UAPassPlus Metadata.

  - `costOfGoodsSold.payments.fop.paymentMetadata.vendorProgramPaymentMetadata.uaPassPlusMetadata.uatpInfo` (object)
    UATP card information for UAPassPlus

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata` (object)
    Metadata for Virtual Card.

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.vendorInfo` (object, required)
    Virtual card related information like vendor, cardId, card-pool id of vendor etc.

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.vendorInfo.vendor` (string)
    Type of Virtual card vendor
    Enum: "CONFERMA"

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.vendorInfo.vendorCardId` (string, required)
    Virtual card id.
    Example: 68793680

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.vendorInfo.virtualCardVendorCardPoolId` (string, required)
    Card pool id of virtual card vendor.
    Example: 51907

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.vendorInfo.confermaInfo` (object)
    Details of conferma - one of virtual card vendors.

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.vendorInfo.confermaInfo.deploymentId` (integer, required)
    Unique identifier assigned to the virtual card deployment at the point of creation.
    Example: 68793680

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.cardInfo` (object)
    Virtual card information like maximum deployment amount, valid date range.

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.cardInfo.dateRange` (object)
    Date range within which the virtual card can be charged.

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.cardInfo.dateRange.startDate` (object, required)
    Local date and time in ISO 8601 format.

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.cardInfo.dateRange.startDate.iso8601` (string, required)
    Example: 2017-07-21T17:32

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.paymentInstructionId` (string)
    Payment instruction id set during addition of virtual card payment source
    Example: 1eb8b778-f0a6-4037-865c-4580982fa36e

  - `costOfGoodsSold.payments.fop.paymentMetadata.virtualCardMetadata.shouldReveal` (boolean)
    Identifier for when to reveal virtual cards as they are revealed to travellers only 24hrs before check-in.
    Example: false

  - `costOfGoodsSold.payments.fop.paymentMetadata.cardMetadata` (object)
    Metadata for Card payment source.

  - `costOfGoodsSold.payments.fop.paymentMetadata.cardMetadata.isLodgeCard` (boolean)
    Whether the payment is made using a lodge card
    Example: false

  - `costOfGoodsSold.payments.fop.paymentMetadata.cardMetadata.bta` (string)
    Whether this is a BTA card. Possible values are 'Y' or 'N'. Relevant only for lodge cards.
    Example: Y

  - `costOfGoodsSold.payments.fop.paymentSourceType` (string)
    Type of Payment Source
    Enum: "CARD", "VIRTUAL_CARD", "REWARDS_PROGRAM", "DELAYED_INVOICING", "CUSTOM_PAYMENT_METHOD", "VENDOR_PROGRAM_PAYMENT", "UNUSED_CREDIT", "CASH"

  - `costOfGoodsSold.payments.paymentReference` (string)
    Reference number for original payment made for this service
    Example: HAH2618716871

  - `costOfGoodsSold.payments.paymentType` (string, required)
    Service for which this payment is made
    Enum: "UNKNOWN", "FLIGHTS", "SERVICE_FEE", "MISCELLANEOUS", "HOTELS", "CARS", "RAILS", "LIMO", "MISC"

  - `costOfGoodsSold.payments.paymentThirdParty` (string)
    Third party who is processing the payment
    Enum: "UNKNOWN_PARTY", "STRIPE", "TFPAY", "TRAINLINE", "BREX", "OUTSIDE_OBT", "RAZORPAY", "EUROSTAR"

  - `costOfGoodsSold.payments.paymentId` (string)
    The payment id for this transaction

  - `costOfGoodsSold.payments.paymentGateway` (string)
    Third party payment gateway used to process the payment
    Enum: "PAYMENT_GATEWAY_UNKNOWN", "STRIPE", "BREX"

  - `costOfGoodsSold.payments.isRefunded` (boolean)
    Whether the payment is refunded to the customer
    Example: false

  - `costOfGoodsSold.payments.selectedPaymentSource` (object)
    Describes the selected payment source for the booking.

  - `costOfGoodsSold.payments.selectedPaymentSource.paymentSourceId` (string)
    Unique identifier identifying this payment source.
    Example: f49d00fe-1eda-4304-ba79-a980f565281d

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource` (object)
    Raw Details of the Payment Source

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.type` (string, required)
    Payment source type. Should be set to DPAN for card details.
    Enum: "DPAN"

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.cardDetails` (object, required)
    Card Details

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.cardDetails.token` (string, required)
    Tokenized Card Number
    Example: 4111111111111111

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.type` (string, required)
    Payment source type. Should be set to CREDIT for unused credit details.
    Enum: "CREDIT"

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.pnrOwningPcc` (string, required)
    PCC the PNR was created on.

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.unusedCreditPcc` (string, required)
    PCC the credit was issued on.

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.departureCountry` (string)
    3 letter country code of the departure country associated with the original ticket.
    Example: USA

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.arrivalCountry` (string)
    3 letter country code of the arrival country associated with the original ticket.
    Example: USA

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.ticketType` (string, required)
    Type of credit.
    Enum: "TICKET_TYPE_UNKNOWN", "ETICKET", "MCO"

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.segmentsAvailable` (string)
    Whether all segments are unused or some have already been used.
    Enum: "UNKNOWN", "ALL_OPEN", "PARTIAL", "OTHER"

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.traveler` (object)
    The traveler identifiers. These can be either the Spotnana user IDs of the travelers or information regarding
the adhoc travelers.

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.airlineInfo` (object, required)
    Detailed information about the airline.

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.airlineInfo.airlineCode` (string, required)
    IATA code for airline.
    Example: AA

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.airlineInfo.airlineName` (string)
    Airline name
    Example: American Airlines

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.source` (string, required)
    Enum: "UNKNOWN_SOURCE", "SABRE", "TRAVEL_FUSION", "AVIA", "NDC", "TRAINLINE", "ATPCO_NDC", "FARELOGIX_NDC", "OFFLINE", "CONNEXUS", "ROUTEHAPPY", "AMADEUS", "GIATA", "QBR", "BCD", "QANTAS_HOTELS", "SOUTHWEST", "EXPEDIA", "HOTEL_HUB", "MARRIOTT", "CLEARTRIP", "KYTE", "GROUNDSPAN", "SABRE_NDC", "BOOKING_COM", "CARTRAWLER", "PREMIER_INN", "TRAVELODGE", "ENTERPRISE", "HYATT", "HILTON", "EUROSTAR", "NATIONAL", "ALAMO", "AVIS", "BUDGET", "HERTZ", "DOLLAR", "THRIFTY", "FIREFLY", "AMADEUS_NDC", "SIXT"

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.sourcePnr` (string, required)
    PNR number corresponding to third party through which booking was made.
    Example: MC5ONS

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.flightIds` (array)
    ID of the flights on which this credit applies.

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.ticketNumber` (string, required)
    Ticket number for the ticket that was converted into an unused credit.
    Example: 5267779139217

  - `costOfGoodsSold.payments.selectedPaymentSource.rawPaymentSource.travelerIndex` (integer)
    credit associated to the traveler having this index in the air search request. If not passed, credit will be associated in order of the travelers
    Example: 2

  - `costOfGoodsSold.payments.selectedPaymentSource.postPaymentRedirectionUrl` (string)
    Url for post payment redirection if payment source navigates user to a third party url
    Example: https://mycompany.com/checkout?paymentSourceId=f49d00fe-1eda-4304-ba79-a980f565281d

  - `costOfGoodsSold.payments.selectedPaymentSource.cvv` (string)
    CVV associated with associated payment source, if any.

  - `costOfGoodsSold.payments.networkTransactionId` (string)
    Network transaction id provided by the card network. Applicable only for cards.
    Example: 721107212171711

  - `costOfGoodsSold.payments.tmcGatewayInfo` (object)
    Tmc Gateway related info.

  - `costOfGoodsSold.payments.tmcGatewayInfo.gatewayType` (string)
    Third party payment gateway used to process the payment
    Enum: "STRIPE", "BREX", "RAZORPAY"

  - `costOfGoodsSold.payments.tmcGatewayInfo.gatewayId` (string)
    GatewayId for related gatewayInfo.
    Example: demo-us:1

  - `costToCustomer` (object)
    Cost of services, charged to customer

  - `costToCustomer.payments` (array, required)
    Potentially multiple payments that spotnana will charge the clients

  - `transactions` (array)

  - `transactions.paymentReqId` (string)
    payment request id
    Example: 3077eeb8-b706-47e5-a762-8442638c07a4

  - `transactions.paymentReference` (string)
    Reference number for original payment made for this service
    Example: pi_3Rgx3qQXFM6BpXYh0kUcOFND

  - `transactions.ctc` (array)

  - `transactions.ctc.isRefunded` (boolean)
    If the relevant amount was refunded.
    Example: true

  - `transactions.ctc.isGuarantee` (boolean)
    If the booking can be reserved now and paid later on site.
    Example: true

  - `transactions.ctc.transactionStatus` (string)
    Transaction status for service fee transaction.
    Enum: "ISSUED", "DELAYED_INVOICE", "FAILED", "CHARGED", "REFUNDED", "FORFEITED", "BILLED_TO_COMPANY", "NO_CHARGE", "GUARANTEE", "TO_BE_CHARGED", "SUCCESS", "MANUAL", "WAIVED_OFF", "TO_BE_ISSUED", "APPLIED", "NOT_APPLICABLE", "DELAYED_PAYMENT"

  - `transactions.itemGroups` (array)

  - `transactions.itemGroups.transactionType` (string)
    type of the transaction
    Enum: "TRIP_SERVICE_FEE", "AIR_TICKET_ISSUED", "AIR_TICKET_VOIDED", "AIR_TICKET_REFUNDED", "AIR_TICKET_EXCHANGED", "AIR_TICKET_UNDETERMINED", "HOTEL_BOOKED", "HOTEL_MODIFIED", "HOTEL_CANCELLED", "CAR_BOOKED", "CAR_MODIFIED", "CAR_CANCELLED", "RAIL_BOOKED", "RAIL_REFUNDED", "RAIL_EXCHANGED", "RAIL_CANCELLED", "LIMO_BOOKED", "LIMO_CANCELLED", "MISC_BOOKED", "MISC_CANCELLED", "FLIGHT_CREDIT_ISSUED", "TMC_FEE", "CHANGE_FEE", "MCO_ISSUED", "EMD_TICKET", "HOTEL_ANCILLARY_BOOKED", "HOTEL_ANCILLARY_CANCELLED"

  - `transactions.itemGroups.confirmationNumber` (string)
    The supplier reference this item group was booked or ticketed under: the ticket number for air, the vendor confirmation number for hotel and car, the order reference id for rail. For air this differs from the PNR-level `vendorConfirmationNumber` because a ticket is issued per traveler.
    Example: 2797091789401

  - `transactions.itemGroups.incompleteTransactionReasons` (array)
    Reasons the underlying booking is incomplete (e.g. SYS_TICKET). Explains why paymentDetails / amounts on the transaction may be empty.

  - `transactions.itemGroups.originalTicketNumber` (string)
    Original ticket number if this is an exchanged ticket

  - `transactions.itemGroups.invoiceData` (object)
    Data related to invoice is kept in this object for an item group

  - `transactions.itemGroups.invoiceData.invoiceNumber` (string)
    The invoice number for an invoice
    Example: 2797091789401

  - `transactions.itemGroups.invoiceData.buyer` (object)
    Buyer of items mentioned in the invoice.

  - `transactions.itemGroups.invoiceData.buyer.name` (string, required)
    Name of buyer, usually a traveler.
    Example: John Doe

  - `transactions.itemGroups.invoiceData.buyer.address` (string, required)
    Address of buyer. Could be office, legal entity or org address.
    Example: 115 Broadway Suite 04-101,
New York, NY 10006

  - `transactions.itemGroups.invoiceData.buyer.taxId` (string)
    Tax number for the seller, for ex GSTN in India
    Example: TXG239023092

  - `transactions.itemGroups.invoiceData.buyer.idInfo` (array)
    The seller ID information.

  - `transactions.itemGroups.invoiceData.buyer.idInfo.idType` (string, required)
    The type of Id.
    Enum: "TAX_ID", "VAT_ID", "VAT_REG_NO", "GST_NO", "ABN", "GSTIN", "SIRET", "BUSINESS_REG_NO", "UID", "CVR_NO", "EIN"

  - `transactions.itemGroups.invoiceData.buyer.idInfo.value` (string, required)
    Value of the Id.
    Example: TXG239023092

  - `transactions.itemGroups.invoiceData.seller` (object)
    Entity that sold the items mentioned in the invoice.

  - `transactions.itemGroups.invoiceData.seller.name` (string, required)
    Name of seller, usually a TMC Legal Entity.
    Example: Spotnana India Pvt. Ltd.

  - `transactions.itemGroups.invoiceData.seller.address` (string, required)
    Address of seller.
    Example: 115 Broadway Suite 04-101,
New York, NY 10006

  - `transactions.itemGroups.invoiceData.seller.taxId` (string)
    Tax number for the seller, for ex GSTN in India
    Example: TXG239023092

  - `transactions.itemGroups.invoiceData.seller.idInfo` (array)
    The seller ID information.

  - `transactions.itemGroups.invoiceData.documentType` (string)
    Type of document generated for an invoice.
    Enum: "INVOICE", "RECEIPT"

  - `transactions.itemGroups.items` (array)

  - `transactions.itemGroups.items.itemType` (string, required)
    Type of the item.
    Enum: "AIR_ITEM", "RAIL_ITEM", "CAR_ITEM", "HOTEL_ITEM", "LIMO_ITEM", "TMC_FEE_ITEM", "MISC_ITEM"

  - `transactions.itemGroups.items.airItemType` (string)
    type of air item
    Enum: "FLIGHT", "ANCILLARY"

  - `transactions.itemGroups.items.flights` (array)

  - `transactions.itemGroups.items.flights.marketing` (object)
    Flight number and airline code.

  - `transactions.itemGroups.items.flights.marketing.num` (string, required)
    Flight number.
    Example: 321

  - `transactions.itemGroups.items.flights.marketing.airlineCode` (string, required)
    Two-letter IATA airline code.
    Example: AA

  - `transactions.itemGroups.items.flights.origin` (object)
    Airport Details

  - `transactions.itemGroups.items.flights.origin.airportCode` (string, required)
    Unique code for the Airport
    Example: LHR

  - `transactions.itemGroups.items.flights.origin.airportName` (string, required)
    Full Name of the Airport
    Example: Heathrow Airport

  - `transactions.itemGroups.items.flights.origin.cityCode` (string, required)
    City Code for the location
    Example: LON

  - `transactions.itemGroups.items.flights.origin.location` (object)
    Location details

  - `transactions.itemGroups.items.flights.origin.groupInfo` (object)
    Grouping criteria for the airports in same group

  - `transactions.itemGroups.items.flights.cabin` (string)
    Flight cabin
    Enum: "UNKNOWN_CABIN", "ECONOMY", "PREMIUM_ECONOMY", "BUSINESS", "FIRST"

  - `transactions.itemGroups.items.flights.marketingAirlineName` (string)
    Name of the marketing airline (enriched from PNR metadata).
    Example: American Airlines

  - `transactions.itemGroups.items.flights.operatingAirlineName` (string)
    Name of the operating airline (enriched from PNR metadata).
    Example: American Airlines

  - `transactions.itemGroups.items.ancillaryTypes` (array)

  - `transactions.itemGroups.items.oldFlights` (array)

  - `transactions.itemGroups.items.airlineConfirmationNumbers` (array)
    Airline confirmation numbers (record locators) for the flights in this item.

  - `transactions.itemGroups.items.legInfos` (array)

  - `transactions.itemGroups.items.legInfos.originInfo` (object)
    Details of the station.

  - `transactions.itemGroups.items.legInfos.originInfo.name` (string, required)
    Name of the station

  - `transactions.itemGroups.items.legInfos.originInfo.code` (string)
    Unique code of the station.

  - `transactions.itemGroups.items.legInfos.originInfo.cityCode` (string)
    City Code for the Railway Station
    Example: LON

  - `transactions.itemGroups.items.legInfos.originInfo.timeZone` (string)
    TimeZone of the Railway Station
    Example: Europe/London

  - `transactions.itemGroups.items.legInfos.originInfo.countryCode` (string)
    Unique Code of the Country of Railway Station
    Example: GB

  - `transactions.itemGroups.items.legInfos.originInfo.localCode` (string)
    Local code of the station.
    Example: EUS1444

  - `transactions.itemGroups.items.legInfos.originInfo.uicCodes` (array)
    List of UIC codes of the station.

  - `transactions.itemGroups.items.legInfos.originInfo.sourceRefInfos` (array)
    Source Reference Info

  - `transactions.itemGroups.items.legInfos.originInfo.stationType` (string)
    Status of the journey.
    Enum: "INDIVIDUAL", "STATION_GROUP", "METRO", "BUS_STOP", "FERRY_TERMINAL"

  - `transactions.itemGroups.items.legInfos.originInfo.cityName` (string)
    City Name of the Railway Station
    Example: LONDON

  - `transactions.itemGroups.items.legInfos.originInfo.stateCode` (string)
    State code for the Railway Station
    Example: MA

  - `transactions.itemGroups.items.legInfos.originInfo.continentCode` (string)
    Unique Code of the Railway Station's Continent
    Example: EU

  - `transactions.itemGroups.items.legInfos.originInfo.spotnanaRailStationId` (integer)
    Canonical Spotnana rail station id.

  - `transactions.itemGroups.items.legInfos.originInfo.thirdPartyInfos` (array)
    Per-supplier codes and inventories for this station.

  - `transactions.itemGroups.items.legInfos.vendorName` (string)
    Name of the rail vendor (enriched from PNR rail leg info).
    Example: Deutsche Bahn

  - `transactions.itemGroups.items.legInfos.carrierName` (string)
    Name of the rail carrier (enriched from PNR rail vehicle info).
    Example: ICE

  - `transactions.itemGroups.items.legInfos.transportName` (string)
    Name of the transport service (enriched from PNR rail vehicle info).
    Example: TGV

  - `transactions.itemGroups.items.legInfos.timetableId` (string)
    Timetable identifier for the rail service (enriched from PNR rail vehicle info).
    Example: ICE 373

  - `transactions.itemGroups.items.legInfos.carrierConfirmationNumber` (string)
    Carrier-specific confirmation number (enriched from PNR rail leg info).
    Example: ABC123

  - `transactions.itemGroups.items.ancillaries` (array)

  - `transactions.itemGroups.items.ancillaries.travelCard` (object)
    Travel card to select.

  - `transactions.itemGroups.items.ancillaries.travelCard.fareType` (object)
    Type of fare.

  - `transactions.itemGroups.items.ancillaries.travelCard.rateInfo` (object)
    Rate for the itinerary.

  - `transactions.itemGroups.items.ancillaries.travelCard.travelCardKey` (string, required)
    Base64 encoded string to uniquely identify the card.
    Example: CilvcH5VfmZmMjU0MjVhLTQ1ZGYtNDRlZi1iYjFmLWRhZTYxMDFkMDhiORIkYjJiMTdkZmYtNDgwNy00YzgyLWI2YWEtMWM5Yjc0ZTEzOWZi

  - `transactions.itemGroups.items.ancillaries.travelCard.validityPeriod` (object)
    Time validity for journey.

  - `transactions.itemGroups.items.ancillaries.travelCard.vendorName` (string, required)
    Vendor which provides the card.
    Example: ATOC

  - `transactions.itemGroups.items.ancillaries.travelCard.zoneValidity` (string)
    Zones in which travel card is valid.
    Example: London Travelcard Zones 1-4

  - `transactions.itemGroups.items.ancillaries.type` (string, required)
    Type of the ancillary
    Enum: "TRAVEL_CARD"

  - `transactions.itemGroups.items.pickUpLocation` (object)
    Pickup and drop-off location info.

  - `transactions.itemGroups.items.pickUpLocation.counterLocation` (string)
    Rental car counter location.
    Enum: "UNKNOWN_COUNTER", "NON_AIRPORT_LOCATION", "IN_TERMINAL", "OFF_AIRPORT_RENTAL_SHUTTLE", "IN_TERMINAL_RENTAL_SHUTTLE", "ON_AIRPORT_RENTAL_SHUTTLE", "ON_AIRPORT_AIRPORT_SHUTTLE", "CALL_FOR_SHUTTLE", "TWO_SHUTTLES_AIRPORT_AND_RENTAL"

  - `transactions.itemGroups.items.pickUpLocation.contactInfo` (object)
    Contact info of the location

  - `transactions.itemGroups.items.pickUpLocation.contactInfo.phone` (array)

  - `transactions.itemGroups.items.pickUpLocation.contactInfo.fax` (array)

  - `transactions.itemGroups.items.pickUpLocation.contactInfo.email` (array)

  - `transactions.itemGroups.items.pickUpLocation.operatingSchedule` (object)
    Operating schedule of vendor

  - `transactions.itemGroups.items.pickUpLocation.operatingSchedule.interval` (array, required)
    Operating schedule interval

  - `transactions.itemGroups.items.pickUpLocation.weeklyOperatingSchedule` (array)
    Weekly operating schedule of vendor

  - `transactions.itemGroups.items.pickUpLocation.weeklyOperatingSchedule.interval` (array, required)
    Operating schedule intervals

  - `transactions.itemGroups.items.pickUpLocation.weeklyOperatingSchedule.dayOfWeek` (string)
    Day of the week for which operating schedule is valid
    Example: SUN

  - `transactions.itemGroups.items.carSpec` (object)
    Car spec.

  - `transactions.itemGroups.items.carSpec.airConditioning` (string)
    Whether air conditioning is available.
    Enum: "UNKNOWN_AC", "AC_AVAILABLE", "AC_NOT_AVAILABLE"

  - `transactions.itemGroups.items.carSpec.amenities` (object)
    Car amenities.

  - `transactions.itemGroups.items.carSpec.amenities.numDoors` (integer)
    Number of doors.
    Example: 4

  - `transactions.itemGroups.items.carSpec.amenities.numLargeBags` (integer)
    Number of large bags.
    Example: 2

  - `transactions.itemGroups.items.carSpec.amenities.numSeatBelts` (integer)
    Number of seats belts.
    Example: 5

  - `transactions.itemGroups.items.carSpec.amenities.numSeats` (integer)
    Number of seats.
    Example: 5

  - `transactions.itemGroups.items.carSpec.amenities.numSmallBags` (integer)
    Number of small bags.
    Example: 5

  - `transactions.itemGroups.items.carSpec.displayName` (string)
    Car display name.
    Example: Economy

  - `transactions.itemGroups.items.carSpec.modelName` (string)
    Car make and model.
    Example: Kia Picanto

  - `transactions.itemGroups.items.carSpec.imageGroups` (array)
    Collection of car images.

  - `transactions.itemGroups.items.carSpec.imageGroups.caption` (string)
    Caption for the image.
    Example: Exterior

  - `transactions.itemGroups.items.carSpec.imageGroups.images` (array, required)
    List of images.

  - `transactions.itemGroups.items.carSpec.transmission` (string)
    Transmission types.
    Enum: "UNKNOWN_TRANSMISSION", "MANUAL_UNSPECIFIED_DRIVE", "MANUAL_4WD", "MANUAL_AWD", "AUTO_UNSPECIFIED_DRIVE", "AUTO_4WD", "AUTO_AWD"

  - `transactions.itemGroups.items.carDailyAverageRate` (object)
    Contains daily rate for the relevant car.

  - `transactions.itemGroups.items.dailyRates` (array)
    Daily rates for rental car in the date range.

  - `transactions.itemGroups.items.vendorCode` (string)
    Car rental vendor code (enriched from PNR car vendor info).
    Example: ZE

  - `transactions.itemGroups.items.vendorName` (string)
    Name of the car rental vendor (enriched from PNR car vendor info).
    Example: Hertz

  - `transactions.itemGroups.items.isPrepaid` (boolean)
    If the booking is prepaid
    Example: false

  - `transactions.itemGroups.items.averageNightlyRate` (object)
    Contains nightly rate for the relevant hotel.

  - `transactions.itemGroups.items.nightlyRates` (array)
    Rates for all nights in stay date range.

  - `transactions.itemGroups.items.hotelData` (object)
    Hotel specific details.

  - `transactions.itemGroups.items.hotelData.hotelName` (string)
    Name of the hotel.
    Example: Marriott Bellandur

  - `transactions.itemGroups.items.rateType` (string)
    Enum: "PUBLISHED", "CORPORATE", "SPOTNANA", "REGULAR", "AAA", "AARP", "SENIOR_CITIZEN", "GOVERNMENT", "MILITARY", "MEMBERSHIP", "BEST_AVAILABLE_RATE", "TMC"

  - `transactions.itemGroups.items.ancillaryCategory` (string)
    Category of the hotel ancillary (only set for ancillary transactions).
    Enum: "ANCILLARY_UNKNOWN", "EARLY_CHECKIN", "LATE_CHECKOUT", "WIFI", "BREAKFAST", "PARKING", "PETS", "MEAL_PLAN", "OTHER"

  - `transactions.itemGroups.items.ancillaryDisplayName` (string)
    Display name of the ancillary (only set for ancillary transactions).

  - `transactions.itemGroups.items.roomName` (string)
    Name of the booked room type (enriched from PNR hotel room spec).
    Example: Standard King Room

  - `transactions.itemGroups.items.limoType` (string)
    Limo type.
    Enum: "STANDARD_CAR", "EXECUTIVE_CAR", "BUSINESS_VAN", "FIRST_CLASS", "SUV", "SEDAN", "EXECUTIVE_SEDAN", "LUXURY_SEDAN", "EXECUTIVE_VAN", "BUSINESS_SEDAN"

  - `transactions.itemGroups.items.vendorName` (string)
    Name of the limo vendor (enriched from PNR limo vendor info).
    Example: Blacklane

  - `transactions.itemGroups.items.feeInfo` (object)
    Details of the fee charged, discriminated by `feeType`.

  - `transactions.itemGroups.items.feeInfo.feeType` (string, required)
    Type of the fee
    Example: BOOKING_FEE

  - `transactions.itemGroups.items.feeInfo.bookingFeeType` (string, required)
    Enum: "TRIP_FEE", "TRANSACTION_FEE"

  - `transactions.itemGroups.items.feeInfo.chargeProcessorInfo` (object)
    Information about the processor that calculated the charge

  - `transactions.itemGroups.items.feeInfo.transactionFeeType` (string)
    Transaction type for service fee
    Enum: "TRANSACTION_TYPE_BOOKING", "TRANSACTION_TYPE_MODIFICATION", "TRANSACTION_TYPE_CANCELLATION", "TRANSACTION_TYPE_AGENT_CONTACT"

  - `transactions.itemGroups.items.feeInfo.bookingFeeType` (string, required)
    Type of the booking fee
    Enum: "VALUE_ADDED_SERVICE_FEE", "OTHER_FEE"

  - `transactions.itemGroups.items.feeInfo.valueAddedServiceFeeType` (string)
    Value added service fee type
    Enum: "VIRTUAL_CARD_PAYMENT", "PRICE_OPTIMIZATION", "UNUSED_CREDIT_APPLICATION", "MERCHANT_FEE"

  - `transactions.itemGroups.items.feeInfo.feeName` (string)
    Name of the fee to be charged.
    Example: Payment Admin Fee

  - `transactions.itemGroups.items.feeInfo.otherFeeType` (string, required)
    Other fee type
    Enum: "MERCHANT_FEE"

  - `transactions.itemGroups.items.feeInfo.agentFeeType` (string, required)
    Enum: "AGENT_ASSISTED_TRIP_FEE", "AGENT_ASSISTED_TRANSACTION_FEE"

  - `transactions.itemGroups.items.visibleToTraveler` (boolean)
    If the tmc fee is visible to traveler
    Example: true

  - `transactions.itemGroups.items.description` (string)
    Free-text description of the miscellaneous segment this item covers, as entered by the agent or carried over from the source booking.
    Example: Visa processing fee

  - `transactions.itemGroups.transactionFares` (array)
    Deprecated: will be removed in transactions v3. Use transactionFareDetails instead.

  - `transactions.itemGroups.transactionFares.transactionFareType` (string)
    type of the fare in this transaction.
    Enum: "BASE_AMOUNT", "OTHER_FEE_AND_TAXES", "PENALTY", "OB_FEES", "DESTINATION_FEES", "TOTAL", "VAT", "DROP_OFF_CHARGE", "HST", "QST", "GST", "CHARGE_BASE", "CHARGE_TOTAL", "SUB_TOTAL", "OB_FEES_GST", "FORFEITED_AMOUNT", "PENALTY_GST", "PENALTY_QST", "PENALTY_HST"

  - `transactions.itemGroups.transactionFares.amountList` (array)

  - `transactions.itemGroups.previousTransactionFares` (array)
    Deprecated: will be removed in transactions v3. Use previousTransactionFareDetails instead.

  - `transactions.itemGroups.transactionFareDetails` (array)
    Detailed fare information for email display.

  - `transactions.itemGroups.transactionFareDetails.chargeCode` (string)
    Charge code for transaction fare detail, used for email display ordering.
    Enum: "BASE", "SUBTOTAL", "CHANGE_FEE_CHARGE", "AIRLINE_FEES_CHARGE", "DESTINATION_FEES_CHARGE", "TOTAL_DELTA", "TOTAL_CHARGE", "CANCEL_FEE_CHARGE", "PREVIOUS_TOTAL_CHARGE", "MISCELLANEOUS_CHARGE", "PREPAID_FEE", "POSTPAID_FEE"

  - `transactions.itemGroups.transactionFareDetails.chargeName` (string)
    Display name for the charge.
    Example: Base

  - `transactions.itemGroups.transactionFareDetails.isInformational` (boolean)
    Whether this is informational only (e.g., subtotal - derived value with no standalone identity).
    Example: false

  - `transactions.itemGroups.transactionFareDetails.taxDefinitions` (array)
    Tax definitions associated with this fare.

  - `transactions.itemGroups.transactionFareDetails.taxDefinitions.taxShortName` (string)
    Short name of the tax (e.g., "Other fees").
    Example: Other fees

  - `transactions.itemGroups.transactionFareDetails.taxDefinitions.taxCode` (string)
    Tax code identifier.
    Example: XF

  - `transactions.itemGroups.transactionFareDetails.taxDefinitions.sortPriority` (integer)
    Sort priority for display ordering within taxes.
    Example: 1

  - `transactions.itemGroups.transactionFareDetails.additionalAmounts` (array)
    Additional amounts for multi-currency scenarios (e.g., USD + Flight Pass).

  - `transactions.itemGroups.transactionFareDetails.sortPriority` (integer)
    Sort priority for display ordering (determines which charge codes appear first).
    Example: 1

  - `transactions.itemGroups.transactionFareDetails.total` (object)
    Computed total for a transaction fare detail with coinage relation.

  - `transactions.itemGroups.transactionFareDetails.total.coinageRelation` (string)
    Relationship between the primary currency amount and other coinage in a fare total.
    Enum: "OR", "AND"

  - `transactions.itemGroups.previousTransactionFareDetails` (array)
    Previous detailed fare information for email display.

  - `transactions.itemGroups.associatedTicketNumber` (string)
    Associated ticket number in case of penalty and taxes in separate ticket

  - `transactions.itemGroups.productName` (string)
    Product name for this item group when the ticket type is EMD.
    Example: REFUNDABLE_BALANCE

  - `transactions.pnrVersion` (integer)
    Version number associated with the Pnr

  - `transactions.splitPayment` (object)
    Split payment details for claiming reimbursements.

  - `transactions.splitPayment.isAmountReimbursable` (boolean)
    If the in policy amount is reimbursable or not.

  - `transactions.bookerInfo` (object)
    Details of User associated with a Transaction

  - `transactions.bookerInfo.bookerName` (string)
    Name of the Booker
    Example: Harry Potter

  - `transactions.bookerInfo.bookerRole` (string)
    User facing role of the Booker
    Enum: "AGENT", "TRAVEL_MANAGER", "TRAVELER", "REGISTRAR", "ADMIN"

  - `isFinalized` (boolean)
    Indicates if finalize action has been performed on the pnr.
    Example: false

  - `policyInfo` (object)
    Policy related info for this booking

  - `policyInfo.outOfPolicy` (boolean, required)
    True if the booking is out of policy, else false
    Example: false

  - `policyInfo.reasonCode` (string)
    Predefined answers to pre search/pre checkout questions
    Enum: "UNKNOWN_CHECKOUT_ANSWER_TYPE", "OTHER", "TIMING_OR_SCHEDULING", "AIRLINE_PREFERENCE", "AIRPORT_PREFERENCE", "MILEAGE_OR_PROGRAM_UPGRADE", "NO_OTHER_OPTION_AVAILABLE", "FASTER_OPTION", "NO_ANSWER", "NOT_AVAILABLE"

  - `policyInfo.reason` (string)
    Free form text if selected reason code is OTHER
    Example: Business class cheaper than economy

  - `policyInfo.appliedPolicyInfo` (object)
    Policy Info applicable for the associated itinerary

  - `policyInfo.appliedPolicyInfo.policies` (array)
    List of policies applied to the itinerary.

  - `policyInfo.appliedPolicyInfo.policies.id` (string, required)
    Policy id

  - `policyInfo.appliedPolicyInfo.policies.version` (string, required)
    version of the policy

  - `policyInfo.appliedPolicyInfo.policies.policyName` (string)
    Name of the policy applied.

  - `policyInfo.appliedPolicyInfo.policies.approvalType` (string)
    Enum: "HARD_APPROVAL", "SOFT_APPROVAL", "PASSIVE_APPROVAL"

  - `policyInfo.appliedPolicyInfo.policies.policyType` (string)
    Enum: "GLOBAL", "DEFAULT", "GROUP"

  - `policyInfo.appliedPolicyInfo.ruleResultInfos` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.predicateString` (string)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.predicate` (string)
    This contains the enum mentioning the policy rule which was violated.
    Enum: "UNKNOWN_PREDICATE_STRING", "MAX_FARE_PER_TRAVELLER_VIOLATION", "FARE_MORE_THAN_MINIMUM", "FARE_MORE_THAN_MEDIAN", "FARE_LESS_THAN_MEDIAN", "FARE_MORE_THAN_LLF", "MAX_FARE_PER_TRAVELLER_VIOLATION_INCLUDING_TAX", "MAX_FARE_PER_TRAVELLER_VIOLATION_EXCLUDING_TAX", "HOTEL_PAYMENT_OPTIONS_VIOLATION", "RAIL_BOOKING_WINDOW_GAP_VIOLATION", "RAIL_TRAVEL_CLASS_VIOLATION", "RAIL_TICKET_REFUNDABLE_VIOLATION", "RAIL_MAX_BOOKING_PRICE_VIOLATION_INCLUDING_TAX", "RAIL_MAX_BOOKING_PRICE_VIOLATION_EXCLUDING_TAX", "AIR_MAX_PRICE_MORE_THAN_LLF_VIOLATION_INCLUDING_TAX", "AIR_MAX_PRICE_MORE_THAN_LLF_VIOLATION_EXCLUDING_TAX", "HOTEL_RESTRICTED_KEYWORDS_VIOLATION", "RESTRICTED_LOCATION_VIOLATION", "FLIGHT_ADVANCE_BOOKING_WINDOW_DOMESTIC_VIOLATION", "FLIGHT_ADVANCE_BOOKING_WINDOW_INTERNATIONAL_VIOLATION", "FLIGHT_ADVANCE_BOOKING_WINDOW_VIOLATION", "ITINERARY_WITHIN_EVENT_TRAVEL_WINDOW", "HOTEL_IN_ALLOWED_HOTEL_LIST", "PAYMENT_ACCESS_VIOLATION", "AIRPORT_IN_ALLOWED_AIRPORT_LIST", "ITINERARY_TYPE_IS_NOT_IN_ALLOWED_BOOKING_TYPES", "PAYMENT_AIR_ADDON_VIOLATION", "MAX_HOTEL_BOOKING_PRICE_INCLUDING_TAX", "MAX_HOTEL_BOOKING_PRICE_EXCLUDING_TAX", "AIR_NUM_TRAVELERS_ALLOWED", "PREFERRED_VENDOR_VIOLATION", "SEAT_ADDON_VIOLATION", "BAGGAGE_ADDON_VIOLATION", "EARLY_BIRD_ADDON_VIOLATION", "WIFI_ADDON_VIOLATION", "RESTRICTED_BOOKING_VIOLATION", "HIGHEST_ALLOWED_CABIN_VIOLATION", "LOWEST_FARE_PER_HOTEL_PROPERTY_VIOLATION", "AIR_RESTRICTED_FARES_VIOLATION", "AIR_ANCILLARY_VIOLATION"

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue` (object)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.displaySuffix` (string)
    Optional display suffix for the policy const value

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.i` (integer)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.l` (integer)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.s` (string)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.d` (number)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.b` (boolean)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.iList` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.dList` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.sList` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.length` (object)
    Specifies the length or a distance.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.length.length` (number, required)
    Distance from search point.
    Example: 150

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.length.unit` (string, required)
    Unit of measure being applied.
    Enum: "UNKNOWN_UNIT", "KM", "MILE", "CENTIMETER", "METER"

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.userOrgIdList` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.legalEntityIdList` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.officeIdList` (array)
    A list of office IDs.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.rating` (number)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.percentage` (number)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.iRange` (object)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.iRange.min` (integer)
    Minimum value - inclusive.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.iRange.max` (integer)
    Maximum value - inclusive.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.dRange` (object)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.dRange.min` (number)
    Minimum value - inclusive.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.dRange.max` (number)
    Maximum value - inclusive.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.personaList` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.railTravelClass` (string)
    Rail Travel classes in hierarchy numbering higher to keep scope for future additions in 
between.
    Enum: "UNKNOWN", "STANDARD", "COACH", "STANDARD_PREMIUM", "BUSINESS", "BUSINESS_PREMIUM", "FIRST", "SLEEPER"

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.keywordWithReasonList` (object)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.keywordWithReasonList.keywords` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.workerTypeList` (array)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.airRestrictedFaresParams` (object)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.violationInfos.expectedValue.airRestrictedFaresParams.airRestrictedKeywords` (array)
    List of keywords grouped by airline

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.subViolationInfos` (array)
    In case of complex rules this will contain extra information as to how the rule was 
calculated.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions` (array)
    Followed actions if rule was satisfied else violated actions.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.flag` (object)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.flag.message` (string)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.hide` (boolean)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.alertOnSelection` (object)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.alertOnSelection.message` (string)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.takeApproval` (object)

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.takeApproval.numHierarchyLevels` (integer)
    How many levels of hierarchy should approval be taken? If it's just immediate manager, 
this value would be 1. If it's manager and their manager, this would ge 2 and so on.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.takeApproval.positionTitles` (array)
    What position in the cost center or department. For eg, any business class upgrade 
might require VP approval.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.takeApproval.userOrgIds` (array)
    The specific users from whom to take approval. For eg, say for a company, all approvals
go through Adam.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.takeApproval.allRequired` (boolean)
    This tells whether all the people above needs to approve or if any of these approve, 
it is sufficient.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.takeApproval.hardApprovalRequired` (boolean)
    Whether to take soft approval (false) or hard approval (true).

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.takeApproval.approvalType` (string)
    Type of APPROVAL
    Enum: "HARD_APPROVAL", "SOFT_APPROVAL", "PASSIVE_APPROVAL", "PRE_APPROVAL"

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.preventBooking` (object)
    Whether to allow booking if a rule is violated.

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.preventBooking.prevent` (boolean)
    True if booking is to be blocked if rule is violated, else false

  - `policyInfo.appliedPolicyInfo.ruleResultInfos.actions.preventBooking.reason` (string)
    Reason describing why was that specific itinerary not allowed to book.

  - `policyInfo.isPersonalUpgrade` (boolean)
    Indicates that this booking exceeded the allowed policy budget with the extra amount being charged on the traveler.
    Example: false

  - `airPnr` (object)
    Air PNR information

  - `airPnr.legs` (array, required)
    List of legs that are part of this bookings

  - `airPnr.legs.flights` (array, required)
    List of flights in this leg

  - `airPnr.legs.flights.flightId` (string)
    Unique identifier for a flight.
    Example: CjoKOGNsYXNzIERhdGVUaW1lTG9jYWwgewogICAgaXNvO

  - `airPnr.legs.flights.origin` (string, required)
    3 letter IATA airport code for origin
    Example: SFO

  - `airPnr.legs.flights.destination` (string, required)
    3 letter IATA airport code for destination
    Example: LHR

  - `airPnr.legs.flights.departureGate` (object)
    Flight boarding / arrival gate

  - `airPnr.legs.flights.departureGate.gate` (string)
    Gate number
    Example: 1A

  - `airPnr.legs.flights.departureGate.terminal` (string)
    Airport terminal
    Example: 1

  - `airPnr.legs.flights.operatingAirlineName` (string)
    Free text operating airline name that has to be displayed to the user if present
    Example: SKYWEST DBA UNITED EXPRESS

  - `airPnr.legs.flights.hiddenStops` (array)
    Stops for refueling or getting more passengers

  - `airPnr.legs.flights.hiddenStops.airport` (string, required)
    3 letter IATA airport code
    Example: LHR

  - `airPnr.legs.flights.vendorConfirmationNumber` (string)
    Flight confirmation number
    Example: ABQTEJ

  - `airPnr.legs.flights.bookingCode` (string)
    Flight Booking Code
    Example: A

  - `airPnr.legs.flights.flightStatus` (string)
    Status of PNR
    Enum: "UNKNOWN", "INITIATED", "CANCELLED", "CONFIRMED", "GROUP_BOOKING_ON_REQUEST", "WAITLISTED", "PENDING", "AIRLINE_UPGRADE", "WAITLIST_CONFIRMED", "BOOKING_DENIED_CONTACT_SUPPORT", "NO_SHOW", "CONTACT_SUPPORT", "STATUS_CHANGED_CONTACT_SUPPORT", "SCHEDULE_CHANGE", "SEGMENT_REQUEST", "SCHEDULE_CHANGE_WAITLISTED_BOOKING", "REQUEST_PENDING", "WAITLISTED_NOT_CONFIRMED", "SCHEDULE_CHANGE_NOT_CONFIRMED", "SCHEDULE_CHANGE_PENDING_STATUS", "MIS_CONNECTION", "REQUESTED", "TICKETED", "VOIDED", "CANCELLED_BY_VENDOR", "CANCELLATION_IN_PROGRESS", "REINSTATED", "BOOKING_ON_HOLD", "AIRLINE_CONTROL", "MODIFIED", "PAYMENT_DECLINED", "INOPERATIVE", "UNCONFIRMED"

  - `airPnr.legs.flights.otherStatuses` (array)
    Details about any duplicate flight segment. Cabin code and status of other duplicate 
segments.

  - `airPnr.legs.flights.co2EmissionDetail` (object)
    CO2 emission details for the flight.

  - `airPnr.legs.flights.co2EmissionDetail.emissionValue` (number, required)
    Estimated C02 emissions value for selected flight and seating class, per passenger (in tons)
    Example: 10

  - `airPnr.legs.flights.co2EmissionDetail.averageEmissionValue` (number)
    Average estimated C02 emissions per passenger for same route (in tons)
    Example: 10

  - `airPnr.legs.flights.co2EmissionDetail.flightDistanceKm` (number)
    Total distance flown by the flight in kilometres.
    Example: 10

  - `airPnr.legs.flights.co2EmissionDetail.isApproximate` (boolean)
    Indicates whether the emissions value is approximate or not.
    Example: true

  - `airPnr.legs.flights.restrictions` (array)
    Restrictions such as seat booking, loyalty etc

  - `airPnr.legs.flights.flightUpdates` (object)
    Flight alerts like departure datetime change, gate change, etc.

  - `airPnr.legs.flights.flightUpdates.baggageBelt` (string)
    Baggage belt / claim carousel number for arrival (from FlightStats)
    Example: 7

  - `airPnr.legs.flights.sourceStatus` (string)
    Flight status code from supplier

  - `airPnr.legs.flights.equipment` (object)
    The type of the aircraft equipment

  - `airPnr.legs.flights.equipment.code` (string)
    Aircraft equipment code
    Example: 777

  - `airPnr.legs.flights.equipment.type` (string)
    Code representing the type of the equipment
    Example: N

  - `airPnr.legs.flights.equipment.name` (string)
    The name of the flight aircraft type
    Example: Boeing 737-800

  - `airPnr.legs.flights.flightWaiverCodes` (array)
    List of waiver codes for flight

  - `airPnr.legs.flights.flightWaiverCodes.waiverCode` (string)
    Flight waiver code

  - `airPnr.legs.flights.flightWaiverCodes.policyLinks` (array)
    List of waiver codes policy link

  - `airPnr.legs.flights.flightWaiverCodes.policyLinks.name` (string)
    Name of the link

  - `airPnr.legs.flights.flightWaiverCodes.policyLinks.url` (string)
    Url of the link

  - `airPnr.legs.flights.flightWaiverCodes.additionalInfo` (string)
    Textual information about waiver policies

  - `airPnr.legs.flights.amenities` (array)
    The amenities associated with the flight.

  - `airPnr.legs.flights.amenities.seatAmenity` (object)
    Seat Amenity properties

  - `airPnr.legs.flights.amenities.seatAmenity.displayText` (string)
    Example: Full flat all aisle access

  - `airPnr.legs.flights.amenities.seatAmenity.seatType` (string)
    Example: full flat pod

  - `airPnr.legs.flights.amenities.seatAmenity.width` (string)

  - `airPnr.legs.flights.amenities.seatAmenity.legroom` (string)

  - `airPnr.legs.flights.amenities.seatAmenity.pitch` (number)
    Example: 78

  - `airPnr.legs.flights.amenities.wifiAmenity` (object)
    Wifi Amenity properties

  - `airPnr.legs.flights.amenities.wifiAmenity.displayText` (string)
    Example: Basic web browsing (fee)

  - `airPnr.legs.flights.amenities.wifiAmenity.cost` (string)
    Example: paid

  - `airPnr.legs.flights.amenities.powerAmenity` (object)
    Power Amenity properties

  - `airPnr.legs.flights.amenities.powerAmenity.displayText` (string)
    Example: Power USB outlets

  - `airPnr.legs.flights.amenities.powerAmenity.powerType` (string)
    Example: power/usb

  - `airPnr.legs.flights.amenities.powerAmenity.cost` (string)
    Example: free

  - `airPnr.legs.flights.amenities.powerAmenity.usbPort` (string)
    Example: yes

  - `airPnr.legs.flights.amenities.powerAmenity.powerOutlet` (string)
    Example: yes

  - `airPnr.legs.flights.amenities.entertainmentAmenity` (object)
    The properties of an entertainment amenity.

  - `airPnr.legs.flights.amenities.entertainmentAmenity.displayText` (string)
    Example: Seatback on-demand video

  - `airPnr.legs.flights.amenities.entertainmentAmenity.entertainmentType` (string)
    Example: on-demand

  - `airPnr.legs.flights.amenities.entertainmentAmenity.cost` (string)
    Example: free

  - `airPnr.legs.flights.amenities.beverageAmenity` (object)
    Beverage amenity option properties.

  - `airPnr.legs.flights.amenities.beverageAmenity.displayText` (string)
    Example: Premium alcohol beverages provided

  - `airPnr.legs.flights.amenities.beverageAmenity.beverageType` (string)
    Example: premium alcoholic

  - `airPnr.legs.flights.amenities.beverageAmenity.alcoholCost` (string)
    Example: free

  - `airPnr.legs.flights.amenities.aircraftAmenity` (object)
    Aircraft Amenity properties

  - `airPnr.legs.flights.amenities.aircraftAmenity.displayText` (string)
    Example: 789 (widebody)

  - `airPnr.legs.flights.amenities.aircraftAmenity.aircraftType` (string)
    Example: widebody

  - `airPnr.legs.flights.amenities.aircraftAmenity.aircraftModel` (string)
    Example: 787

  - `airPnr.legs.flights.amenities.layoutAmenity` (object)
    Layout Amenity properties

  - `airPnr.legs.flights.amenities.layoutAmenity.displayText` (string)
    Example: 1-2-1 seat layout

  - `airPnr.legs.flights.amenities.layoutAmenity.directAisleAccess` (string)
    Example: yes

  - `airPnr.legs.flights.amenities.freshFoodAmenity` (object)
    Properties associated with the fresh food amenity.

  - `airPnr.legs.flights.amenities.freshFoodAmenity.displayText` (string)

  - `airPnr.legs.flights.amenities.freshFoodAmenity.freshFoodType` (string)

  - `airPnr.legs.flights.amenities.freshFoodAmenity.cost` (string)

  - `airPnr.legs.flights.amenities.cleaningAmenity` (object)
    Cleaning amenity properties.

  - `airPnr.legs.flights.amenities.cleaningAmenity.displayText` (string)
    Example: Enhanced aircraft cleaning every flight

  - `airPnr.legs.flights.amenities.cleaningAmenity.cleaningDescription` (string)
    Example: This flight features an aircraft that will be thoroughly cleaned using disinfectants for every flight

  - `airPnr.legs.flights.amenities.cleaningAmenity.cleaningAttrDescription` (string)
    Example: enhanced every flight

  - `airPnr.legs.flights.amenities.maskAmenity` (object)
    Properties associated with the mask amenity.

  - `airPnr.legs.flights.amenities.maskAmenity.displayText` (string)
    The basic text displayed for mask amenity.
    Example: Face covering required

  - `airPnr.legs.flights.amenities.maskAmenity.maskDescription` (string)
    A full description of the mask amenity.
    Example: All passengers are required to wear a face covering throughout their journey

  - `airPnr.legs.flights.amenities.maskAmenity.maskAttrDescription` (string)
    Example: yes

  - `airPnr.legs.flights.amenities.temperatureAmenity` (object)
    Temperature Amenity properties

  - `airPnr.legs.flights.amenities.temperatureAmenity.displayText` (string)
    Example: No pre-flight temperature check

  - `airPnr.legs.flights.amenities.temperatureAmenity.temperatureDescription` (string)
    Example: A temperature check is not required before boarding

  - `airPnr.legs.flights.amenities.temperatureAmenity.temperatureAttrDescription` (string)
    Example: no

  - `airPnr.legs.flights.amenities.passengerCapacityAmenity` (object)
    Passenger capacity amenity properties.

  - `airPnr.legs.flights.amenities.passengerCapacityAmenity.displayText` (string)
    Example: Standard passenger capacity

  - `airPnr.legs.flights.amenities.passengerCapacityAmenity.passengerCapacityDescription` (string)
    Example: Ticket sales are not limited for this flight

  - `airPnr.legs.flights.amenities.passengerCapacityAmenity.passengerCapacityAttrDescription` (string)
    Example: no

  - `airPnr.legs.flights.amenities.blockedAdjacentSeatsAmenity` (object)
    Passenger Capacity Amenity properties

  - `airPnr.legs.flights.amenities.blockedAdjacentSeatsAmenity.displayText` (string)
    Example: No blocked adjacent seats

  - `airPnr.legs.flights.amenities.blockedAdjacentSeatsAmenity.blockedAdjacentSeatsDescription` (string)
    Example: Adjacent seats are not blocked on this flight

  - `airPnr.legs.flights.amenities.blockedAdjacentSeatsAmenity.blockedAdjacentSeatsAttrDescription` (string)
    Example: no

  - `airPnr.legs.flights.amenities.covidTestingAmenity` (object)
    Covid testing amenity properties.

  - `airPnr.legs.flights.amenities.covidTestingAmenity.displayText` (string)
    Example: No COVID-19 test required

  - `airPnr.legs.flights.amenities.covidTestingAmenity.covidTestingDescription` (string)
    Example: A negative COVID-19 test is not required for this flight; check with the airline for possible destination requirements or other restrictions.

  - `airPnr.legs.flights.amenities.covidTestingAmenity.covidTestingAttrDescription` (string)

  - `airPnr.legs.flights.amenities.vaccineAmenity` (object)
    Vaccine Amenity properties

  - `airPnr.legs.flights.amenities.vaccineAmenity.displayText` (string)
    Example: Vaccination facility available

  - `airPnr.legs.flights.amenities.vaccineAmenity.vaccineDescription` (string)
    chek

  - `airPnr.legs.flights.amenities.vaccineAmenity.vaccineAttrDescription` (string)

  - `airPnr.legs.flights.flightIndex` (integer)
    Index of flight in the leg
    Example: 0

  - `airPnr.legs.flights.upas` (array)

  - `airPnr.legs.flights.upas.headline` (string)
    Example: A fully flat bed

[...]
